"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const DesignType_1 = require("./DesignType");
class DesignUsage {
    constructor(id, type, description) {
        this.id = id;
        this.type = type;
        this.description = description;
    }
    get byteLength() {
        return (this.type === DesignType_1.DesignType.Pro) ? 2160 : 620;
    }
    get colorDataLength() {
        return (this.type === DesignType_1.DesignType.Pro) ? 2048 : 512;
    }
    static fromId(id) {
        return this.all.find(d => d.id === id);
    }
}
exports.DesignUsage = DesignUsage;
DesignUsage.LongSleeveDress = new DesignUsage(0, DesignType_1.DesignType.Pro, 'Long-sleeve dress');
DesignUsage.ShortSleeveDress = new DesignUsage(1, DesignType_1.DesignType.Pro, 'Short-sleeve dress');
DesignUsage.SleevelessDress = new DesignUsage(2, DesignType_1.DesignType.Pro, 'Sleeveless dress');
DesignUsage.LongSleeveShirt = new DesignUsage(3, DesignType_1.DesignType.Pro, 'Long-sleeve shirt');
DesignUsage.ShortSleeveShirt = new DesignUsage(4, DesignType_1.DesignType.Pro, 'Short-sleeve shirt');
DesignUsage.SleevelessShirt = new DesignUsage(5, DesignType_1.DesignType.Pro, 'Sleeveless shirt');
DesignUsage.HornedHat = new DesignUsage(6, DesignType_1.DesignType.Pro, 'Horned hat');
DesignUsage.KnitCap = new DesignUsage(7, DesignType_1.DesignType.Pro, 'Knit cap');
DesignUsage.Standee = new DesignUsage(8, DesignType_1.DesignType.Pro, 'Standee');
DesignUsage.CustomDesign = new DesignUsage(9, DesignType_1.DesignType.Normal, 'Custom design');
DesignUsage.UnknownUsage010 = new DesignUsage(10, DesignType_1.DesignType.Normal, 'Unknown Usage #10');
DesignUsage.UnknownUsage011 = new DesignUsage(11, DesignType_1.DesignType.Normal, 'Unknown Usage #11');
DesignUsage.all = [
    DesignUsage.LongSleeveDress,
    DesignUsage.ShortSleeveDress,
    DesignUsage.SleevelessDress,
    DesignUsage.LongSleeveShirt,
    DesignUsage.ShortSleeveShirt,
    DesignUsage.SleevelessShirt,
    DesignUsage.HornedHat,
    DesignUsage.KnitCap,
    DesignUsage.Standee,
    DesignUsage.CustomDesign,
    DesignUsage.UnknownUsage010,
    DesignUsage.UnknownUsage011,
];
