/// <reference types="node" />
import { DesignType } from './DesignType';
import { Writable } from 'stream';
export declare class QRData {
    readonly type: DesignType;
    index?: number;
    parity?: number;
    constructor(type: DesignType, index?: number, parity?: number, bytes?: Uint8Array);
    static fromBytes(bytes: Uint8Array, index?: number, parity?: number): QRData;
    private byteLength;
    private _bytes;
    /**
     * The underlying bytes for this QR data segment.
     */
    get bytes(): Uint8Array;
    set bytes(value: Uint8Array);
    private qrSegments;
    toFile(path: string): Promise<void>;
    toFileStream(stream: Writable): Promise<void>;
    toDataUrl(type?: 'png' | 'jpeg' | 'webp'): Promise<string>;
    toCanvas(canvas?: unknown): Promise<unknown>;
}
